#include "StdAfx.h"
#include ".\textfile.h"

TextFile::TextFile(BOOL tabs, BOOL blanks)
: m_numberOfLines(0)
{
	////////m_textArray/////////////////////
	m_textArray = new char*[1000]; // Zeilen
	for (int i=0; i < 1000; i++)
	{
		m_textArray[i] = new char[1000]; // columns
		strcpy( m_textArray[i], "" );
	}

	////////m_wordArray/////////////////////
	m_wordArray = new char**[1000]; // rows
	for (int i=0; i < 1000; i++)
	{
		m_wordArray[i] = new char*[100]; // columns
	}

	for (int i=0; i < 1000; i++)
	{
		for (int j=0; j < 100; j++)
		{
			m_wordArray[i][j] = new char[100]; // words
			strcpy( m_wordArray[i][j], "nix!" );
		}
	}

	initDelimitlers( tabs, blanks );
}

TextFile::~TextFile(void)
{
	////////m_textArray/////////////////////
	for (int i=0; i < 1000; i++)
	{
		delete[] m_textArray[i];
	}
	delete[] m_textArray;

	////////m_wordArray/////////////////////
	for (int i=0; i < 1000; i++)
	{
		for (int j=0; j < 100; j++)
		{
			delete[] m_wordArray[i][j]; // words
		}
	}

	for (int i=0; i < 100; i++)
	{
		delete[] m_wordArray[i]; // columns
	}

	delete[] m_wordArray;
}

BOOL TextFile::readFile(char* filename)
{
	ifstream file (filename);
	BOOL ok = file.is_open();
	if (! ok) return ok;

	int lineIndex = -1;
	while (! file.eof() )
	{
		lineIndex++;
		file.getline (m_textArray[lineIndex],1000);
	}

	// Do not count empty lines at the end of the file ...
	while( strcmp( m_textArray[lineIndex], "" ) == 0 )
	{
		lineIndex--;
	}

	file.close();
	m_numberOfLines = lineIndex+1;

	putTextArrayInWordArray();
	
	return ok;
}

void TextFile::showTextArray(void)
{
	printf("\n");
	for (int i=0; i < m_numberOfLines; i++)
	{
		printf("\n");
		printf(m_textArray[i]);
	}
	printf("\n\n");
}

void TextFile::putLineInWordArray(int linenumber)
{
	int wordcounter = 0;
	char *buffer = m_textArray[linenumber];
	int length = strlen( buffer );

	char word[100];
	int currentPos = 0; char currentChar = buffer[currentPos];
	int currentWordPos = 0;

	while (currentPos < length)
	{
		strcpy( word, "" ); currentWordPos = 0;
		if (checkWordDelimiter( currentChar ))
		{
			currentPos++; currentChar = buffer[currentPos];
		}
		while ((!checkWordDelimiter( currentChar )) && (currentPos < length))
		{
			word[currentWordPos] = buffer[currentPos];
			currentPos++; currentChar = buffer[currentPos];
			currentWordPos++;
		}
		word[currentWordPos] = '\0';
		strcpy( m_wordArray[linenumber][wordcounter], word );
		wordcounter++;
	}

	strcpy( m_wordArray[linenumber][wordcounter], "|||" );
}

BOOL TextFile::checkWordDelimiter(char character)
{
	for (int i=0; i < 6; i++)
	{
		if (character == delimiters[i])
			return true;
	}
	
	return false;
}

void TextFile::putTextArrayInWordArray(void)
{
	for (int i=0; i < m_numberOfLines; i++)
	{
		putLineInWordArray( i );
	}
}

void TextFile::showWordArray(void)
{
	printf("\n\n");
	for (int line = 0; line < m_numberOfLines; line++)
	{
		int i=0;
		while ( strcmp( m_wordArray[line][i], "|||") != 0 )
		{
			printf(m_wordArray[line][i]); printf(" ");
			i++;
		}
		printf("\n");
	}
}


int TextFile::returnmaxNumColumns(void)
{
	int result = 0;
	
	for (int line = 0; line < m_numberOfLines; line++)
	{
		int i=0;
		while ( strcmp( m_wordArray[line][i], "|||") != 0 )
		{
			i++;
		}
		if ( i > result )
			result = i;
	}
	
	return result;
}

void TextFile::initDelimitlers(BOOL tabs, BOOL blanks)
{
	delimiters[0] = '\n';
	delimiters[1] = '\r';
	delimiters[2] = '\v';
	delimiters[3] = '\f';

	if (tabs)
		delimiters[4] = '\t';
	else
		// we have it anyway
		delimiters[4] = '\n';

	if (blanks)
		delimiters[5] = ' ';
	else
		delimiters[5] = '\n';
	
}


